<template>
  <div
    v-if="value"
    class="q-pa-sm"
  >
    <q-card flat>
      <q-card-section v-if="title">
        <div class="text-h5 text-weight-bolder text-grey-9 q-px-sm q-pt-sm">
          {{ title }}
        </div>
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-md">
          <q-input
            v-model="value.zipcode"
            class="col-12 q-pa-sm"
            label="CEP"
            color="primary"
            mask="#####-###"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.zipcode.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.zipcode)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.street"
            class="col-6 q-pa-sm"
            label="Logradouro"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.street.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.street)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            ref="streetNumber"
            v-model="value.streetNumber"
            class="col-6 q-pa-sm"
            label="Número"
            color="primary"
            mask="######"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.streetNumber.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.streetNumber)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.complementary"
            class="col-6 q-pa-sm"
            label="Complemento"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.complementary.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.complementary)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.neighborhood"
            class="col-6 q-pa-sm"
            label="Bairro"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.neighborhood.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.neighborhood)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-model="value.city"
            class="col-6 q-pa-sm"
            label="Município"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.city.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.city)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-select
            v-model="value.state"
            :options="states"
            class="col-6 q-pa-sm"
            label="Estado"
            color="primary"
            options-cover
            options-dense
            bottom-slots
            map-options
            emit-value
            outlined
            dense
            :error="vuelidate.state.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.state)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-select>
        </q-form>
      </q-card-section>
    </q-card>
  </div>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { StatesMixin } from '../../mixin/states'

export default {
  name: 'Address',
  mixins: [ErrorMessagesMixin, StatesMixin],
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    vuelidate: {
      type: Object,
      default: () => ({})
    },
    title: {
      type: String,
      default: () => ('')
    }
  },
  watch: {
    'value.zipcode' (zipcode) {
      if (!zipcode) {
        return undefined
      }

      if (zipcode.length === 8) {
        this.searchZipcode(zipcode)
      }
    }
  },
  methods: {
    async searchZipcode (zipcode) {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: `Zipcodes/${zipcode}`
        }

        const Response = await this.$axios(axiosConfig)
          .then(R => R.data)
          .finally(() => this.$q.loading.hide())

        Response.zipcode = Response.cep
        delete Response.service
        delete Response.cep

        Object.assign(this.value, Response)
        this.$refs.streetNumber.focus()
      } catch (e) {
        return undefined
      }
    }
  }
}
</script>
